/*
Copyright 2020 The SuperEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package common

const (
	// maxRetries is the number of times a kind of workload will be retried before it is dropped out of the queue.
	// With the current rate-limiter in use (5ms*2^(maxRetries-1)) the following numbers represent the times
	// a resource is going to be requeued:
	//
	// 5ms, 10ms, 20ms, 40ms, 80ms, 160ms, 320ms, 640ms, 1.3s, 2.6s, 5.1s, 10.2s, 20.4s, 41s, 82s
	MaxRetries = 15

	DeploymentGridKind  = "DeploymentGrid"
	StatefulSetGridKind = "StatefulSetGrid"
	ServiceGridKind     = "ServiceGrid"

	DefaultTemplateName = "default"

	ParentClusterSecretNamespace = "clusternet-system"
	ParentClusterSecretName      = "parent-cluster"

	ParentURLKey = "parent-url"
)
